<template>
  <div class="center">
    <div class="item account">
      <span class="icon">
        <img src="/login/User.png" alt="" />
      </span>
      <input
        type="text"
        v-model="memberMobile"
        :placeholder="L['请输入手机号']"
        class="input"
      />
      <div
        data-type="userName"
        class="cancel"
        @click="clearInputVal('memberMobile')"
      >
        <span class="iconfont icon-cuowu"></span>
      </div>
    </div>
    <div class="error">
      <span
        v-if="mobileErrorMsg"
        class="iconfont icon-jubao"
      ></span>
      {{ mobileErrorMsg }}
    </div>
    <!-- 邮箱验证码 -->
    <div class="verify-code">
      <span class="verify-code-icon">
        <img src="/login/Code.png" alt="" />
      </span>
      <input
        type="text"
        v-model="mobileCode"
        :placeholder="L['请输入验证码']"
        class="input"
        autocomplete="off"
      />
      <span class="verify-code-accept">
        <el-button
          @click="showHMVerify"
          :disabled="countDownNumer"
          :loading="getVerifyCodeLoading"
        >
          <span>{{ codeText }}</span>
          <span v-if="countDownNumer">{{ `(${countDownNumer})` }}</span>
        </el-button>
      </span>
    </div>
    <div class="error">
      <span
        v-if="mobileCodeErrorMsg"
        class="iconfont icon-jubao"
      ></span>
      {{ mobileCodeErrorMsg }}
    </div>
    <div class="item password">
      <span class="icon">
        <img src="/login/Password.png" alt="" />
      </span>
      <input
        :type="showPwdFlag ? 'text' : 'password'"
        v-model="password"
        :placeholder="L['请输入密码']"
        class="input"
        @focus="checkPwdValidate"
        @blur="checkPwdValidate"
      />
      <div class="cancel" @click="isShowPwd">
        <span
          :class="{
            iconfont: true,
            'icon-bukejian11': !showPwdFlag,
            'icon-kejian': showPwdFlag,
            show_pwd: showPwdFlag,
          }"
        ></span>
      </div>
      <div class="error">
        <span
          v-if="checkPwdErrorMsg"
          class="iconfont icon-jubao"
        ></span>
        {{ checkPwdErrorMsg }}
      </div>
    </div>
    <div class="item confirm">
      <span class="icon">
        <img src="/login/Password.png" alt="" />
      </span>
      <input
        class="input"
        v-model="confirmPassword"
        :type="showConfirmPwdFlag ? 'text' : 'password'"
        :placeholder="L['register']['请确认密码']"
        @blur="checkPwdMatched"
      />
      <div class="cancel" @click="isShowConfirmPwd">
        <span
          :class="{
            iconfont: true,
            'icon-bukejian11': !showConfirmPwdFlag,
            'icon-kejian': showConfirmPwdFlag,
            show_pwd: showConfirmPwdFlag,
          }"
        ></span>
      </div>
    </div>
    <div class="error">
      <span
        v-if="checkErrorMsg"
        class="iconfont icon-jubao"
      ></span>
      {{ checkErrorMsg }}
    </div>
    <el-button
      @click="forgetPwd"
      :class="{ submit: true, disabled: forgetPwdDisabled }"
      :disabled="forgetPwdDisabled"
      :loading="forgetPwdLoading"
      >{{ L["确认"] }}</el-button
    >
    <el-dialog
      :title="L['register']['滑动验证']"
      destroy-on-close
      width="500px"
      center
      modal-class="retrieve-verify-model"
      v-model="modalVisible"
    >
      <SliderVerify
        :slideVerifyOptions="{ show: false, w: 450, h: 220 }"
        @onSuccess="verifySuccess"
        @onFail="verifyFail"
      />
    </el-dialog>
  </div>
</template>

<script setup>
import { showMessage, startCountdown } from "@/utils/common";
import { getCurLanguage } from "@/composables/common.js";

const emits = defineEmits(["success"]);

const L = getCurLanguage();
const mobileCalc = ref();
const memberMobile = ref(""); //用户邮箱
const mobileErrorMsg = ref(); //错误提示
const mobileCode = ref(""); // 邮箱验证码
const mobileCodeErrorMsg = ref(); //验证码错误提示

// 倒计时展示
const countDownNumer = ref(0);
const getVerifyCodeLoading = ref(false);
// 人机验证弹窗显示标识
const modalVisible = ref(false);

// 重新获取验证码标识
const isReacquireCode = ref(false);

const checkErrorMsg = ref(""); // 密码一致性错误提示
const password = ref(""); //密码
const confirmPassword = ref(""); //二次确认密码
const showPwdFlag = ref(false); //密码是否明文显示，默认密文
const showConfirmPwdFlag = ref(false); // 二次密码是否明文显示，默认密文

const forgetPwdLoading = ref(false);
const checkPwdErrorMsg = ref("");

const forgetPwdDisabled = computed(
  () => !memberMobile.value || !password.value || !confirmPassword.value
);

// 获取验证码的文案
const codeText = computed(() => {
  return isReacquireCode.value
    ? L["register"]["重新获取"]
    : L["register"]["获取验证码"];
});

//密码是否显示
const isShowPwd = () => {
  showPwdFlag.value = !showPwdFlag.value;
};

const checkPwdValidate = () => {
  const res = unifyValidatePassword(password.value); 
  if (!res.ok) {
    checkPwdErrorMsg.value = res.reasons[0];
    return false;
  }

  checkPwdErrorMsg.value = ''
  return true;
};

//开启人机校验
const showHMVerify = () => {
  // 校验手机非空以及格式
  if (!validatePhone()) return;
  modalVisible.value = true;
};

// 二次确认密码是否显示
const isShowConfirmPwd = () => {
  showConfirmPwdFlag.value = !showConfirmPwdFlag.value;
};

const checkPwdMatched = () => {
  if (password.value === confirmPassword.value) {
    checkErrorMsg.value = "";
    return true;
  }
  checkErrorMsg.value = L["register"]["两次输入的密码不一致"];
  return false;
};

// 人机验证成功
const verifySuccess = () => {
  modalVisible.value = false;
  getVerifyCode();
};

//清空输入框内容
const clearInputVal = (type) => {
  if (type == "memberMobile") {
    memberMobile.value = "";
  }
};

// 人机校验失败
const verifyFail = () => {
  showMessage({
    message: L["register"]["校验不通过"],
    type: "warning",
  });
};

// 校验邮箱
const validatePhone = () => {
  //邮箱非空的验证
  if (!memberMobile.value) {
    mobileErrorMsg.value = L["请输入邮箱"];
    return false;
  }

  // 邮箱格式验证
  mobileCalc.value = checkPhone(memberMobile.value);
  if (mobileCalc.value !== true) {
    mobileErrorMsg.value = mobileCalc.value;
    return false;
  }
  mobileErrorMsg.value = "";

  return true;
};

// 邮箱验证码验证
const validateMobileCode = () => {
  if (!mobileCode.value) {
    mobileCodeErrorMsg.value = L["register"]["请输入邮箱验证码"];
    return false;
  }
  mobileCodeErrorMsg.value = "";

  return true;
};

const getVerifyCode = () => {
  getVerifyCodeLoading.value = true;
  post("v3/member/front/active/verification/code", {
    mobile: memberMobile.value,
    source: 1,
    type: 2, // 忘记密码
  })
    .then((res) => {
      if (res.state === 200) {
        showMessage({
          message: L["register"]["验证码已发送"],
          type: "success",
        });
        // 设置倒计时
        startCountdown(60, (time) => (countDownNumer.value = time));
        isReacquireCode.value = true;
      } else {
        showMessage({
          message: res.msg,
          type: "warning",
        });
      }
    })
    .finally(() => {
      getVerifyCodeLoading.value = false;
    });
};

const forgetPwd = () => {
  if (!validatePhone() || !validateMobileCode() || !checkPwdValidate() || !checkPwdMatched()) return;
  forgetPwdLoading.value = true;
  post("v3/member/front/active/email/reset/pwdNew", {
    confirmPassWord: confirmPassword.value,
    mobile: memberMobile.value,
    loginPwd: password.value,
    verificationCode: mobileCode.value,
  })
    .then((res) => {
      if (res.state == 200) {
        //成功提示，并返回到登录页面
        showMessage({
          message: L["register"]["重置成功"],
          type: "success",
        });
        emits("success");
      } else {
        //提示错误
        showMessage({
          message: res.msg,
          type: "error",
        });
      }
    })
    .finally(() => {
      forgetPwdLoading.value = false;
    });
};

watch(memberMobile, (val) => {
  if (val) {
    mobileErrorMsg.value = "";
  }
});

watch(mobileCode, (val) => {
  if (val) {
    mobileCodeErrorMsg.value = "";
  }
});
</script>

<style lang="scss" scoped>
.center {
  flex: 1;
  height: 100%;
  position: relative;
  padding: 0 28px;
  margin-top: 60px;

  .item {
    position: relative;
    margin-top: 15px;
    border-radius: 2px;

    &:first-child {
      margin-top: 0;
    }

    .icon {
      display: flex;
      align-items: center;
      justify-content: flex-end;
      position: absolute;
      left: 1px;
      top: 1px;
      width: 50px;
      height: 46px;

      img {
        width: 22px;
        height: 22px;
        position: relative;
        right: 5px;
      }
    }

    .input {
      border: 1px solid #e8e8e8;
      height: 48px;
      padding: 0 44px 0 60px;
      width: 431px;
      font-size: 14px;
    }

    &.code {
      .input {
        padding-right: 10px;
        width: 150px;
      }
    }
  }

  .cancel {
    position: absolute;
    right: 0;
    top: 1px;
    text-align: center;
    line-height: 46px;
    width: 44px;
    height: 46px;
    cursor: pointer;

    .iconfont {
      font-size: 16px;

      &.show_pwd {
        font-size: 20px;
      }
    }
  }

  .error {
    margin-top: 5px;
    position: relative;
    color: #e2231a;
    height: 22px;
    line-height: 16px;

    .iconfont {
      font-size: 14px;
    }
  }

  .verify-code {
    display: flex;
    width: 431px;
    height: 48px;
    margin-top: 10px;

    &-icon {
      display: flex;
      align-items: center;
      justify-content: flex-end;
      width: 50px;
      height: 48px;
      border: 1px solid #e8e8e8;
      border-right: none;

      img {
        width: 22px;
        height: 22px;
        position: relative;
        right: 5px;
      }
    }

    input {
      flex: 1;
      width: 100%;
      border: 1px solid #e8e8e8;
      border-left: none;
      border-right: none;
      height: 48px;
      padding: 0 0 0 10px;
      font-size: 14px;
    }

    &-accept {
      display: flex;
      justify-content: center;
      align-items: center;
      width: 90px;

      .el-button {
        width: 100%;
        height: 100%;
        color: #fff;
        background-color: $colorMain;
        border-left: none;
        border-radius: 0;
        font-size: 12px;

        &.is-disabled {
          background-color: #909399;
        }

        &:hover {
          // border-color: #e8e8e8;
          // color: $colorMain;
        }
      }
    }
  }

  .submit {
    margin-top: 50px;
    background: $colorMain;
    color: #fff;
    text-align: center;
    border-radius: 2px;
    width: 100%;
    height: 45px;
    font-size: 18px;
    letter-spacing: 0px;

    &:hover {
      opacity: 0.9;
    }

    &.disabled {
      background-color: #909399;
    }
  }
}
</style>
